<?

//create the array buffer from the file
function
readhist(){
    global $username,$buffer,$datadir;
    $file=$datadir.$username;
    $buffer=file("$file");
}

//grows the history array from the filebuffer
function
growhist($buffer,$history,$nohist){
    $a=0;
    //seed for keeping timestamps uniq
    $b=1;
    for ($i=0;$i<=sizeof($buffer);$i++){
        if (ereg("^history ",$buffer[$i])){
            $data=losefirstword($buffer[$i]);
            $stamp=getfirstword($data);
            // is the history entry sane (with a timestamp)
            if (preg_match('/^\d+$/',$stamp) == 1){
                $history[$a]=$buffer[$i];
            }else{
                $tstamp=time();
                //keep timestamps unique
                $tstamp=$tstamp-$b;
                $history[$a]="history ".$tstamp." ".$data."\n";
                $history[mod]=1;
            }
            $a++;
            $b++;
        }
    }
    return $history;
}

//grows the aliases array from the file buffer
function
growali($buffer,$aliases){
    global $builtinaliases;
    $a=$builtinaliases;
    for ($i=0;$i<=sizeof($buffer);$i++){
        if (ereg("^alias ",$buffer[$i])){
            $aliases[]=$buffer[$i];
            $a++;
        }
    }

    return $aliases;
}

function
prepaliases($aliases){
    //refine the aliases array
    for($x=0;$x<sizeof($aliases);$x++){
        $aliases[$x]=losefirstword($aliases[$x]);
    }
    return $aliases;
}

//grows the notes array from the file buffer
function
grownotes($buffer,$notes,$isnote){
    if(isset($isnote)){
        $a=1;
    }else{
        $a=0;
    }

    //seed for keeping timestamps uniq
    $seed=1;
    for ($i=0;$i<=sizeof($buffer);$i++){
        if (ereg("^note ",$buffer[$i])){
            $data=losefirstword($buffer[$i]);
            $stamp=getfirstword($data);
            // is the notes entry sane (with a timestamp)
            if (preg_match('/^\d+$/',$stamp) == 1){
                $notes[$a]=$buffer[$i];
            }else{
                //if it is not sane, make it sane and note that
                //it was modified.
                $tstamp=time();
                //keep timestamps unique
                $tstamp=$tstamp-$seed;
                $notes[$a]="note ".$tstamp." ".$data."\n";
                $notes[mod]=1;
            }
            $a++;
            $seed++;
        }

    }
    return $notes;
}

//writes the aliases and history entries to the file
function
writehist($history,$aliases,$notes,$excludes){
    global $hlength,$builtinaliases,$datadir,$username;
    $file=$datadir.$username;
    $fp=fopen("$file","w");
    if ($fp==0){
        printf("Unable to write to history file[%s]. Check permissions or turn off history.\n",$file);
        exit;
    }

    if ( flock($fp,LOCK_EX) ){

        if (sizeof($notes)>0){
            while(list($i,$value)=each($notes)){
                fwrite($fp,"$notes[$i]");
            }
        }

        if (sizeof($aliases)>0){
            //unset leaves empty keys!!! SUCKS!
            $useraliases=array_values($aliases);
            for($i=$builtinaliases;$i<=sizeof($useraliases);$i++){
                fwrite($fp,"$useraliases[$i]");
            }
        }

        if (sizeof($history)>0){
            //unset leaves empty keys!!! SUCKS!
            $userhistory=array_values($history);
            for ($i=0;$i<$hlength; $i++) {
                fwrite($fp,"$userhistory[$i]");
                }
        }

        if (sizeof($excludes)>0){
            while(list($i,$value)=each($excludes)){
                fwrite($fp,"$excludes[$i]");
            }
        }

        flock($fp,LOCK_UN);

    }else{
        printf("Unable to lock %s. Aborting.<br>\n",$file);
        exit;
    }

	
    fclose($fp);
}

//prints history entries
//A $type of 'short' will print only the history entries with no forms or sthead
function
printhist($history,$nohist,$type,$limit){
    global $PHP_SELF;
    if ($limit==-1){
        $limit=sizeof($history);
    }

    if ( $type!="short" ){
        sthead();
        printform();
		ckall();
        if (sizeof($history)>0){
            print("<table class=\"history\">\n");
            print("<form method=\"POST\" name=\"h\" action=\"".$PHP_SELF."\">\n");
            print("<tr><td><input type=\"button\" name=\"SelectAll\" onClick=\"selectall(document.h)\" value=\"Select&nbsp;All\"><input type=\"button\" name=\"DeselectAll\" onClick=\"deselect(document.h)\" value=\"Deselect&nbsp;All\"><input type=\"submit\" name=\"deletehistory\" value=\"Delete\"></td></tr>\n");
        }
    }
    if (sizeof($history)>0){
		if (sizeof($history)<$limit){ $limit=sizeof($history); };
        print("<p class=\"history\">\n");
        for($x=0;$x<$limit;$x++){
            if (empty($history[$x])){
                /* 
                    If history entries have been deleted, the keys will 
                    stick around, so the limit needs to be increased to 
                    make up for the empty keys.
                */
                $limit++;
            }else{
                $value=losefirstword($history[$x]); //history
                $value=losefirstword($value); //tstamp
                $value=stripslashes($value);
                $value=trim($value);
                $yesyes=urlencode($value);
                $tstamp=getfirstword(losefirstword($history[$x]));
                if ( $type!="short" ){
                    printf("<tr><td><input type=\"checkbox\" name=\"tagged_%s\" value=\"%s\">&nbsp;",$tstamp,$tstamp,$tstamp);
                }

                printf("<a href=\"$PHP_SELF?userdata=%s\" target=\"_self\">%s</a><br>\n",$yesyes,$value);
                if ( $type!="short" ){
                    print("</td></tr>\n");
                }
            }
        } // for loop 
    }else{ //sizeof history greater than 0
        print("You have no history entries to be displayed.<br>\n");
    }
    if ( $type!="short" ){
        if (sizeof($history)>0){
            print("<tr><td><input type=\"button\" name=\"SelectAll\" onClick=\"selectall(document.h)\" value=\"Select&nbsp;All\"><input type=\"button\" name=\"DeselectAll\" onClick=\"deselect(document.h)\" value=\"Deselect&nbsp;All\"><input type=\"submit\" name=\"deletehistory\" value=\"Delete\"></td></tr>\n");
            print("</form></table>\n");
        }
        if (sizeof($history)>15){
            printform();
        }
        stfoot();
        exit;
    }
}

//print just the aliases
function
shortprintali($aliases,$seperator){
    global $PHP_SELF,$builtinaliases;
    if (sizeof($aliases)>0){
        print("<p class=\"aliases\">\n");
        for ($x=$builtinaliases;$x<sizeof($aliases);$x++){
            $keyword=getfirstword(losefirstword($aliases[$x]));
            if ( (! ereg("\{",$aliases[$x]) ) && ( ereg("http://",$aliases[$x]) || ereg("ftp://",$aliases[$x]) ) ){
                printf("<a href=\"%s\">%s</a>%s\n",losefirst2words($aliases[$x]),$keyword,$seperator);
            }else{
                printf("%s %s\n",$keyword,$seperator);
            }
        }
    }else{
        print("You have no aliases to be displayed.<br><br>\n");
        print("To create an alias, type the following:<br>\n");
        print("<b>alias shorthand substitution</b><br>\n");
        print("in the form above, where <b>shorthand</b> is what you will type instead of typing <b>substitution</b>. <br>For example:<br>\n");
        print("<b>alias phpman www.php.net/manual</b>\n");
    }
}

function
printbuiltins(){
    global $aliases,$builtinaliases;
    print("<tr><td colspan=2><p>The following aliases are built-in\n");
    print("and cannot be deleted w/o modifying the script. They\n");
    print("are presented as examples.</p></td></tr>\n");

    for ($x=0;$x<$builtinaliases;$x++){
        $aliases[$x]=trim($aliases[$x]);
        $keyword=getfirstword(losefirstword($aliases[$x]));
        printf("<tr><td><b>%s</b></td>\n",$keyword);
        printf("<td>%s</td></tr>\n",losefirst2words($aliases[$x]));
    }
    print("</table>\n");
}

//print the aliases
function
printaliases($aliases,$nohist){
    global $PHP_SELF,$builtinaliases;
    sthead();
    printform();
	ckall();
    if (sizeof($aliases)-$builtinaliases>0){

        print("<table border=0 cellspacing=3 cellpadding=3>\n");
        print("<form method=\"POST\" name=\"a\" action=\"".$PHP_SELF."\">\n");
		print("<tr><td><input type=\"button\" name=\"SelectAll\" onClick=\"selectall(document.a)\" value=\"Select&nbsp;All\"><input type=\"button\" name=\"DeselectAll\" onClick=\"deselect(document.a)\" value=\"Deselect&nbsp;All\"><input type=\"submit\" name=\"deletealias\" value=\"Delete\"></td></tr>\n");

        for ($x=$builtinaliases;$x<sizeof($aliases);$x++){
            $aliases[$x]=trim($aliases[$x]);
            $keyword=getfirstword(losefirstword($aliases[$x]));

            //print the start of the form
            printf("<tr><td><input type=\"checkbox\" name=\"tagged_%s\" value=\"%s\">&nbsp;",$keyword,$keyword);


            //See if the alias should be rendered as a link
            if ( (! ereg("\{",$aliases[$x]) ) && ( ereg("http://",$aliases[$x]) || ereg("ftp://",$aliases[$x]) ) ){
                printf("<b><a href=\"%s?userdata=%s&nohist=1\">%s</a></b></td>\n",$PHP_SELF,urlencode(losefirst2words($aliases[$x])),$keyword);
                print("<td>\n");
                printselfurl(losefirst2words($aliases[$x]));
                print("</td></tr>\n");
            }else{
                printf("<b>%s</b></td>\n",$keyword);
                printf("<td>%s</td></tr>\n",losefirst2words($aliases[$x]));
            }
        } // for loop

		print("<tr><td><input type=\"button\" name=\"SelectAll\" onClick=\"selectall(document.a)\" value=\"Select&nbsp;All\"><input type=\"button\" name=\"DeselectAll\" onClick=\"deselect(document.a)\" value=\"Deselect&nbsp;All\"><input type=\"submit\" name=\"deletealias\" value=\"Delete\"></td></tr>\n");
        print("</form>\n");
        printbuiltins();

    }else{ //if sizeof
        print("You have no aliases to be displayed.<br><br>\n");
        print("To create an alias, type the following:<br>\n");
        print("<b>alias shorthand*substitution</b><br>\n");
        print("in the form above, where <b>shorthand</b> is what you will type instead of typing <b>substitution</b>. <br>For example:<br>\n");
        print("<b>alias phpman*www.php.net/manual</b><hr>\n");

        print("<table border=0 cellspacing=3 cellpadding=3>\n");
        printbuiltins();
    }
    if (sizeof($aliases)>15){
        printform();
    }
    stfoot();
    exit;
}

//prints the notes
//A $type of 'short' will print only the notes instead of the notes screen
function
printnotes($view,$nohist,$type){
    global $PHP_SELF,$notes;
    if (sizeof($notes)>0){
        if ( $type=="short" ){
            print ("<p class=\"notes\">\n");

            while(list($key,$value)=each($notes)){
                $id=getfirstword(losefirstword($value));
                $value=losefirstword(losefirstword($value));
                $value=stripslashes($value);
				$value=urlize($value);
                print($value."<br>\n");
            }

            print ("</p>\n");
        }else{ //if short

            //beginning of long
            sthead();
            printform();
			ckall();
            print("<p class=\"notes\">\n");
            print ("<table border=0 cellpadding=0 cellspacing=0><tr><td colspan=2 valign=\"middle\">\n");
            printf("<form method=\"POST\" name=\"n\" action=\"".$PHP_SELF."\">\n");

            while(list($key,$value)=each($notes)){
                $id=getfirstword(losefirstword($value));
                $value=losefirstword(losefirstword($value));
                $value=stripslashes($value);
                printf("<input type=\"checkbox\" name=\"tagged_%s\" value=\"%s\"> %s<br>\n",$id,$id,urlize($value));
            }

            print ("<br>\n");
			print("<input type=\"button\" name=\"SelectAll\" onClick=\"selectall(document.n)\" value=\"Select&nbsp;All\"><input type=\"button\" name=\"DeselectAll\" onClick=\"deselect(document.n)\" value=\"Deselect&nbsp;All\"><input type=\"submit\" name=\"deletenote\" value=\"Delete\">\n");
            print ("</form>\n");
            print ("</td></tr></table>\n");
            print ("</p>\n");
            //end of long
        }//long vs short

    }else{
        if ( $type!="short" ){
			sthead();
			printform();
		}
        print("You have no notes to be displayed.<br><br>\n");
        print("To create a note, simply type:<br>\n");
        print("<b>note <i>whatever you want</i></b><br>\n");
        print("in the form above.<br>\n");
        if ( $type!="short" ){
			stfoot();
		}
    }
    if ( $type!="short" ){
        if (sizeof($notes)>15){
            printform();
        }
        stfoot();
        exit;
    }
}

function
editor(){
    global $PHP_SELF,$username,$datadir;
    $file=$datadir.$username;
    if (! file_exists("$file")){
        if (touch("$file")==false){
            print("Unable to read or write history file. Please check permissions.\n");
            exit;
        }
    }

    $fp = fopen ( $file , "r+");
    $contents = fread($fp, filesize($file));
    fclose($fp);
    $contents = stripslashes($contents);

    sthead();
    print("<form action=\"$PHP_SELF\" method=POST name=fd>\n");
    print("<table><tr><td>");
    printf("<textarea cols=85 rows=30 name=filedata>%s</textarea><br>\n",$contents);
    print("</td></tr><tr><td>");
    print("<input type=submit value=\"Save Changes\" align=middle>\n");
    print("<input type=reset name=reset value=\"Reset\">\n");
    print("</td></tr></table>");
    print("</form>\n");
    printform();
    stfoot();
    exit;
}

function
whichalias($aliases,$userdata){
    //compares the first word of userdata to the alias array keywords
    $all_args=explode(" ",$userdata);
    for ($i=0;$i<sizeof($aliases);$i++){
        $keyword=getfirstword($aliases[$i]);
        if ( $keyword==$all_args[0] ){
            return $aliases[$i];
        }
    }
}

function
buildurlfromalias($myalias,$userdata){

    $max_args=10;

    // this is all arguments passed.
    $all_args=losefirstword($userdata);

    // this is an array of individual arguments including the "command"
    $passed_args = explode(" ", $userdata);

    $num_args = count($passed_args) - 1;
    if ($num_args <= 0 ) {
        return losefirstword($myalias);
    }

    // $mold is the command line we'd like to make
    // first start by making it equal to $myalias
    $mold=$myalias;

    // start with ${0}  and continue through ${n} where n is max_args
    for( $i=0; $i<= $max_args; $i++){
        $mold=str_replace( "\$\{$i}", trim($passed_args[$i]), $mold );
    }
    // get the ${*} if its there.
    if (ereg("\{\*\}",$mold)){
        $all_args=urlencode(trim($all_args));
        $mold = str_replace( "\${*}", $all_args, $mold );
    }

    $mold=losefirstword($mold);
    return $mold;

}

//grows the aliases array from the file buffer
function
growexcludes($buffer){
    for ($i=0;$i<=sizeof($buffer);$i++){
        if (ereg("^exclude ",$buffer[$i])){
            $excludes[]=$buffer[$i];
        }
    }

    return $excludes;
}

function
ckall(){
	print("<script language=\"javascript\">\n");
	print("<!--\n");
	print("function selectall(field)\n{\n");
	print("for (i = 0; i < field.length; i++)\n");
	print("\tfield[i].checked = true ;\n}\n");
	print("function deselect(field)\n{\n");
	print("for (i = 0; i < field.length; i++)\n");
	print("\tfield[i].checked = false ;\n}\n");
	print("// -->\n</script>\n");
}

function
historysearch($criteria){
	global $PHP_SELF,$history;
	print("<table class=\"history\">\n");
	print("<form method=\"POST\" name=\"h\" action=\"".$PHP_SELF."\">\n");
	print("<tr><td><input type=\"button\" name=\"SelectAll\" onClick=\"selectall(document.h)\" value=\"Select&nbsp;All\"><input type=\"button\" name=\"DeselectAll\" onClick=\"deselect(document.h)\" value=\"Deselect&nbsp;All\"><input type=\"submit\" name=\"deletehistory\" value=\"Delete\"></td></tr>\n");

	for ($x=0;$x<sizeof($history);$x++){
		if (ereg($criteria,$history[$x])){
			$value=losefirstword($history[$x]); //history
			$value=losefirstword($value); //tstamp
			$value=stripslashes($value);
			$value=trim($value);
			$yesyes=urlencode($value);
			$tstamp=getfirstword(losefirstword($history[$x]));
			printf("<tr><td><input type=\"checkbox\" name=\"tagged_%s\" value=\"%s\">&nbsp;",$tstamp,$tstamp,$tstamp);
			printf("<a href=\"$PHP_SELF?userdata=%s\">%s</a><br>\n",$yesyes,$value);
			print("</td></tr>\n");
		}
	}
}


?>
