<?

//prints the help page
function
printhelp(){
    header("Cache-Control: no-cache, must-revalidate");
    header("Pragma: no-cache");
    sthead();
    printform();

print <<< END
<p> 
	<b>NAME</b><br>
	<ul><p>Deadman's Redirect 5</p></ul>
</p>

<p> 
	<b>COPYRIGHT</b><br>
	<ul>
		<p>Deadman's Redirect is (C) 2001 Sam Rowe</p>
	</ul>
</p>

<p> 
	<b>DESCRIPTION</b><br>
	<ul>
		<p>Deadman's Redirect (DMR) is a personal portal system written
		in PHP4. The main interface to DMR is via an HTML form 
		consisiting of both a text-box and several buttons.</p>

		<p>DMR understands the following protocol prefixes:
			<ul>
				<li>http://
				<li>https://
				<li>ftp://
				<li>file://
				<li>irc://
			</ul>
		</p>

		<p>If text entered into DMR is not a DMR command or alias and 
		does not have one of the above prefixes, http:// will be 
		prepended to the string and it will be treated as a URL.
	</ul>
</p>

<p> 
	<b>CONVENTIONS</b><br>
	<ul>
		<p>Reserved words entered into the text box will be refered 
		to as a &quot;command&quot; and will be <i>italisized</i>. 
		When referring to buttons, text will be <u>underlined</u> and 
		the button name will be capitalized.</p>
	</ul>
</p>

<p> 
	<b>INSTALLATION</b><br>
	<ul>
		<p>DMR must be able to write in the directory defined in 
		<a href="#datadirvar">\$datadir</a> below. Due to the nature 
		of PHP, PHP scripts have the same user permissions as the web 
		server. If your webserver is unable to write to the defined 
		directory, DMR won't be able to either.</p>
	</ul>
</p>

<p> 
	<b>DEFINITIONS</b><br>
	<ul>
		<table cellpadding=5>
		<tr><td valign=top><b>history</b></td><td valign=top>
			<a name="historydef"></a>
			<p>Any command or URI which is entered into DMR and 
			is not in the list of exceptions, is kept in a 
			file/array. Exceptions: <i>\$hon, \$hoff, \$hdisplay, 
			\$adisplay, \$remind, \$forget, view&nbsp;[viewname], 
			edit&nbsp;[viewname], $unsetviewcook, 
			alias&nbsp;[alias&nbsp;definition], 
			note&nbsp;[note&nbsp;definition], helpbutton, 
			nohelpbutton, dmr&nbsp;[search&nbsp;pattern], 
			\$unsetcook, help");</i>.</p>
		</td></tr>

		<td valign=top><b>note</b></td><td valign=top>
			<a name="notedef"></a>
			<p>A single line of text consisting of non-blank 
			character(s).</p>
		</td></tr>

		<td valign=top><b>alias</b></td><td valign=top>
			<a name="aliasdef"></a>
			<p>Aliases allow a string to be substituted in a given 
			URL. Aliases are case-sensitive.</p>
		</td></tr>

		<td valign=top><b>screen</b></td><td valign=top>
			<a name="screendef"></a>
			<p>Any of the various HTML documents produced by DMR.</p>
		</td></tr>

		<td valign=top><b>view</b></td><td valign=top>
			<a name="viewdef"></a>
			<p>A view is a user-defined template that defines the 
			manner in which DMR screens will be rendered.</p>
		</td></tr>
	</table>
</ul>

<p> 
	<b>OPTIONS</b><br>
	<ul>
		<p>DMR has several variables that must be set and a whole bunch
		more that can be customized or left as the default. Variables 
		that must be changed are marked with an asterisk (*).</p>

		<table cellpadding=5>

			<tr><td valign=top><b>\$phpext</b></td><td valign=top>
				<a name="phpextvar"></a>
				<p>Set this to your web server's PHP extension. 
				If this is not set correctly, DMR will not 
				behave as expected.</p>
			</td></tr>

		<tr><td valign=top><b>\$useRssItemDescription</b></td><td valign=top>
            <a name="userssitemdesc"></a>
            <p>Set to 1 if you want to see the Description data for RSS 
            &lt;item&gt;'s. Set to 0 if not. If this is turned on, it is 
            still possible to only display the Description data from 
            certain RSS feeds via CSS (see below.)</p>
        </td></tr>

		<tr><td valign=top><b>\$proxyhost</b></td><td valign=top>
            <a name="proxyhost"></a>
            <p>If you are behind a proxy, the |rdf| command will not work
            unless you set this variable to the IP or hostname of your proxy.
            Note: DMR's proxy support is <b>only</b> for the |rdf| feature.
            If you do not use a proxy, leave this variable empty.</p>
        </td></tr>

        <tr><td valign=top><b>\proxyport</b></td><td valign=top>
            <a name="proxyport"></a>
            <p>If you have defined \$proxyhost above, you must define the
            port your proxy uses here.</p>
        </td></tr>

		<tr><td valign=top><b>\$datadir</b></td><td valign=top>
			<a name="datadirvar"></a>
			<p>This is the directory in which DMR will write (and 
			read) all of its data. This directory should be outside 
			of your web tree to prevent browsers from reading your 
			data files. This directory must be in, or relative to, 
			the PHP include path and include a trailing slash.</p>
		</td></tr>

		<tr><td valign=top><b>\$backupdir</b></td><td valign=top>
            <a name="backupdirvar"></a>
            <p>This directory is used by <i>backup</i> and <i>restore</i>
            to keep/restore a backup copy of history/aliases/notes and views.</p>
        </td></tr>

		<tr><td valign=top><b>\$autobackup</b></td><td valign=top>
            <a name="autobackup"></a>
            <p>Toggles automatic backups. If turned on, a cookie is set
            whose value is raised every time DMR is viewed. When the cookie
            value equals the value set in \$autobackupinterval, a backup
            is done. The DMR Remote does not increment this value.
            </p>
        </td></tr>

		<tr><td valign=top><b>\$autobackupinterval</b></td><td valign=top>
            <a name="autobackupinterval"></a>
            <p>The number of DMR pageviews between each autobackup.</p>
        </td></tr>

		<tr><td valign=top><b>\$viewtemplate</b></td><td valign=top>
			<a name="viewtemplatevar"></a>
			<p>The contents of the file defined in this variable
			will be added to the view editor when a new view is
			created. This file must exist in \$datadir.</p>
		</td></tr>

		<tr><td valign=top><b>\$formlength</b></td><td valign=top>
			<a name="formlengthvar"></a>
			<p>Defines the width (in characters) of the DMR text 
			box.</p>
		</td></tr>

		<tr><td valign=top><b>\$bookmarkfile</b></td><td valign=top>
			<a name="bookmarkfilevar"></a>
			<p>Defines the path to the file that should be searched 
			when the <a href="#filesearch"><i>//</i></a> command is 
			used.</p>
		</td></tr>

		<tr><td valign=top><b>\$usecokies</b></td><td valign=top>
			<a name="usecookiesvar"></a>
			<p>Toggles the use of a cookie-based authentication 
			system.</p>
		</td></tr>

		<tr><td valign=top><b>\$formtype</b></td><td valign=top>
			<a name="formtypevar"></a>
			<p>Defines the type of form used to authenticate to DMR 
			if the cookie-based authentication system is used. 
			(password|text)</p>
		</td></tr>

		<tr><td valign=top><b>* \$setcook</b></td><td valign=top>
			<a name="setcookvar"></a>
			<p>If the cookie-based authentication system is used, 
			the value defined here is your password.</p>
		</td></tr>

		<tr><td valign=top><b>\$authtime</b></td><td valign=top>
            <a name="authtimevar"></a>
            <p>The time to live for the cookie set by \$setcook</p>
		</td></tr>

		<tr><td valign=top><b>\$unsetcook</b></td><td valign=top>
			<a name="unsetcookvar"></a>
			<p>If the cookie-based authentication system is used, 
			the value defined here can be used to erase the 
			authentication cookie.</p>
		</td></tr>

		<tr><td valign=top><b>\$unsetviewcook</b></td><td valign=top>
			<a name="unsetviewcookvar"></a>
			<p>The value defined here can be used to erase the view 
			cookie. This can be used if, for whatever reason, your
			view fails to render (bad tables for ex.) The default
			value for \$unsetviewcook is &quot;killview&quot;. In
			order to use this command, you need to fake a GET to
			DMR, like so: <br>
			<b>http://www.mysite.com/path/to/dmr.php?userdata=killview</b>
			<br>Some browsers will endlessly loop when faked out
			like this. If yours does, press the Stop button on your
			browser and reload DMR without the faked GET.</p>
		</td></tr>

		<tr><td valign=top><b>* \$tempcook</b></td><td valign=top>
			<a name="tempcookvar"></a>
			<p>If the cookie-based authentication system is used, 
			the value defined here can be used to temporarily 
			authenticate a browser to DMR. The cookie will remain 
			until the browser session ends.</p>
		</td></tr>

		<tr><td valign=top><b>\$edit</b></td><td valign=top>
			<a name="editvar"></a>
			<p>The value defined here will load the <a 
			href="#edit">Edit</a> screen with the 
			history/notes/aliases file loaded for editing.</p>
		</td></tr>

		<tr><td valign=top><b>\$hlength</b></td><td valign=top>
			<a name="hlengthvar"></a>
			<p>The number of <a href="#historydef">history</a> 
			entries that should be saved.</p>
		</td></tr>

		<tr><td valign=top><b>\$username</b></td><td valign=top>
			<a name="usernamevar"></a>
			<p>The value defined here will be used to create the 
			file in which history/notes/aliases will be written.</p>
		</td></tr>

		<tr><td valign=top><b>\$hon</b></td><td valign=top>
			<a name="honvar"></a>
			<p>The value defined here can be used to turn history 
			on after it has been turned off via \$hoff.</p>
		</td></tr>

		<tr><td valign=top><b>\$hoff</b></td><td valign=top>
			<a name="hoffvar"></a>
			<p>The value defined here will set a cookie that turns 
			off the history functionality of DMR.</p>
		</td></tr>

		<tr><td valign=top><b>\$hdisplay</b></td><td valign=top>
			<a name="hdisplayvar"></a>
			<p>The value defined here will display the History 
			screen.  Entering this command has the same effect as 
			clicking the <a href="#history"><u>History</u></a> 
			button.</p>
		</td></tr>

		<tr><td valign=top><b>\$adisplay</b></td><td valign=top>
			<a name="adisplayvar"></a>
			<p>The value defined here will display the Aliases 
			screen.  Entering this command has the same effect as 
			clicking the <a href="#aliases"><u>Aliases</u></a> 
			button.</p>
		</td></tr>

		<tr><td valign=top><b>\$ndisplay</b></td><td valign=top>
			<a name="ndisplayvar"></a>
			<p>The value defined here will display the Notes screen.
			Entering this command has the same effect as clicking 
			the <a href="#notes"><u>Notes</u></a> button.</p>
		</td></tr>

		<tr><td valign=top><b>\$remind</b></td><td valign=top>
			<a name="remindvar"></a>
			<p>The value defined here will set a cookie. If this 
			cookie is found, DMR will print a small-font list of 
			the currently defined <a href="#aliasdef">aliases</a> 
			in/near the main form.</p>
		</td></tr>

		<tr><td valign=top><b>\$forget</b></td><td valign=top>
			<a name="forgetvar"></a>
			<p>The value defined here will erase the cookie set by 
			\$remind.</p>
		</td></tr>
	</table>
</ul>

<p> 
	<b>COMMANDS</b><br>
	<ul>
		<p>Many of DMR's commands are definable by using the variables 
		above. The ones that are not are listed here.</p>

		<table cellpadding=5 cellspacing=5>

		<tr><td valign=top><i>--</i>TEXT</td><td valign=top>
            <a name="dashdash"></a>
            <p>Starting your data with -- has the exact same effect as
            clicking the &quot;Skip&nbsp;History&quot; checkbox.
            -- can also be added to the end of data with the same effect.</p>
            <p><b>EXAMPLE</b><br>
                <ul><p>--search something interesting</p></ul></p>
            <p>This search will not be entered into history.</p>
		</td></tr>

		<tr><td valign=top><i>!!</i>...[:p]</td><td valign=top>
			<a name="bangbang"></a>
			<p><i>!!</i> represents the most recent history entry 
			(<b>not</b> the most recent command.) Using it as a 
			command has the same effect as clicking the <a 
			href="#history"><u>History</u></a> button and clicking 
			the most recent history entry.</p>
			<p>Alternately, <i>!!</i> can be used as a 
			psuedo-variable that can be added to new DMR operations.
			</p><p><b>EXAMPLE</b><br>
				<ul><p>http://www.deadman.org/redirect/<br>alias dmr !!</p>
				    <p>The second command aliases dmr to 
                    http://www.deadman.org/redirect/ <p>
				</ul>
			</p>
			<p>In either case :p can be added to the end of the
			data string to print the results, rather than using
			the results as the current data.</p>
		</td></tr>

		<tr><td valign=top><i>!*</i>...[:p]</td><td valign=top>
			<a name="bangdollar"></a>
			<p><i>!*</i> is not a command per se, but a 
			pseudo-variable that represents all of the arguments to 
			the previous command given to DMR.</p>  
			<p> 
				<b>EXAMPLE</b><br>
				<ul>
					<p><i>!*</i> is most commonly used to 
					search for the same data on different 
					search engines.<br><br>
					google green eggs and ham<br>ebay !*</p>
					<p>The second command would search Ebay 
					for &quot;green eggs and ham&quot;.</p>
				</ul>
			</p>
			<p>:p can be added to the end of the data string to 
			print the results, rather than using the results as 
			the current data.</p>
		</td></tr>

		<tr><td valign=top><i>!?</i>PATTERN...[:p]</td><td valign=top>
			<a name="bangquestion"></a>
			<p>Replace !?PATTERN with the most recent history entry containing
			<u>PATTERN</u>. If the search 
			fails, DMR will discard the request.</p>
			<p><b>EXAMPLE</b><br>
				<ul><p>!?tutorial</p>
                <p>alias mytut !?tutorial</p></ul>
			</p>
			<p>:p can be added to the end of the data string to 
			print the results, rather than using the results as 
			the current data.</p>
		</td></tr>

		<tr><td valign=top><i>^</i>PATTERN1<i>^</i>PATTERN2...[:p]</td><td valign=top>
			<a name="circumflex"></a>
			<p>Repeat the last history entry replacing PATTERN1
			with PATTERN2. If the substitution fails, DMR will
			discard the request. PATTER2 must contain 
			non-whitespace characters.</p>
			<p><b>EXAMPLE</b><br>
				<ul><p>search lilo tutorial<br>
					^lilo^grub</p>
					<p>The second command would search
					google for &quot;grub tutorial&quot;</p>
				</ul>
			</p>
			<p>:p can be added to the end of the data string to 
			print the results, rather than using the results as 
			the current data.</p>
		</td></tr>

		<tr><td valign=top><i>//</i> PATTERN<i></td><td valign=top>
			<a name="filesearch"></a>
			<p><i>//</i> is used to search the file defined in
			<a href="#bookmarkfilevar">\$bookmarkfile</a>. This 
			command takes one argument.</p>
		</td></tr>

		<tr><td valign=top><i>alias</i>&nbsp;SHORTHAND&nbsp;SUBSTITUTION</td>
		<td valign=top>
			<p>There are two types of DMR aliases. The first type is
			used to shorten a long url to one keyword.</p>
			<p> 
				<b>EXAMPLES</b><br>
				<ul>
					<i>alias phpman 
					http://www.php.net/manual/en/</i><br>
					<i>alias tool toolshed.down.net</i><br>
				</ul> 
			</p>
			<p>Now, instead of entering the full URL to get to the 
			PHP manual, only <i>phpman</i> is required. Remember, 
			DMR can handle incomplete URL's, but if you enter the 
			http:// DMR will know it is a complete URL and will 
			render it as a clickable link.</p>

			<a name="varsub"></a>
			<p>The second type involves variable substitution and is
			most often used to make DMR the front-end for a 
			search-engine.  An alias can have up to ten (10) 
			functional arguments or one, all-inclusive argument. 
			The individual arguments are represented by \${1} 
			through \${10}. The all-inclusive argument is 
			represented with \${*}. Numbered arguments cannot be 
			used with \${*}.</p> 

			<p> 
				<b>EXAMPLES</b><br>
				<ul>
					<i>alias f 
					http://freshmeat.net/search.php3?q=\${*}</i><br>
					<i>alias me 
					http://www.mysite.com/~myhomedir/\${*}</i><br>
					<i>alias site 
					http://www.\${1}/\${2}</i><br> 
				</ul>
			</p>

			<p> Note that the first alias is the same as the 
			built-in &quot;freshmeat&quot; alias. It is possible to 
			have any number of aliases point to the same URL.</p>

			<p>If you wish to update an existing alias, simply 
			redefine it as if you were newly creating it.  This 
			only works for user-defined aliases. To change the 
			built-in aliases, you'll have to modify the DMR script 
			itself.</p>

            <p>It is not possible to alias DMR commands or other DMR aliases.</p>
		</td></tr>

		<tr><td valign=top><i>backup</i></td><td valign=top>
            <p>This command creates a backup copy of the history/aliases/notes
            data as well as all views. The copies are placed in the directory
            defined in \$backupdir. </p>
        </td></tr>

		<tr><td valign=top><i>dmr</i>&nbsp;PATTERN</td><td valign=top>
			<p>The <i>dmr</i> command will search through existing 
			<a href="#historydef">history</a> entries and return any
			that match PATTERN. This command takes one 
			argument.</p>
		</td></tr>

		<tr><td valign=top><i>edit</i>&nbsp;VIEWNAME</td>
		<td valign=top>
			<p><i>edit</i> with arguments is the command equivalent
			of the <a href="#edit"><u>Edit</u></a> button. With no 
			arguments, <i>edit</i> is the equivalent to the default 
			value of <a href="#editvar">\$edit</a> See also: <a 
			href="#files">FILES</a>.</p>
		</td></tr>

		<tr><td valign=top><i>exclude</i>&nbsp;PATTERN</td><td valign=top>
			<p>Use this keyword to tell DMR to auto<i>magic</i>ally
			exclude items <b>beginning</b> with PATTERN from 
			history.</p>
		</td></tr>

		<tr><td valign=top><i>help</i></td><td valign=top>
			<p><i>help</i> is the text eqivalent of the <a 
			href="#help"><u>Help</u></a> button.</p>
		</td></tr>

		<tr><td valign=top><i>helpbutton</i></td><td valign=top>
			<a name="helpbutton"></a>
			<p><i>helpbutton</i> will erase the cookie set by 
			<i>nohelpbutton</i>.</p>
		</td></tr>

		<tr><td valign=top><i>listviews</i></td><td valign=top>
			<p><i>listviews</i> is the <i>command</i> equivalent of
			the <a href="#views"><u>Views</u></a> button.</p>
		</td></tr>

		<tr><td valign=top><i>nohelpbutton</i></td><td valign=top>
			<a name="nohelpbutton"></a>
			<p><i>nohelpbutton</i> sets a cookie that disables the 
			rendering of the <a href="#help"><u>Help</u></a> 
			button.</p>
		</td></tr>

		<tr><td valign=top><i>note</i>&nbsp;TEXT</td><td valign=top>
			<p>The <i>note</i> command is used to enter a 
			single-line of text to be noted for later.</p>
		</td></tr>

		<tr><td valign=top><i>oops</i></td><td valign=top>
            <p><i>oops</i> deletes the most recent history entry</p>
        </td></tr>

		<tr><td valign=top><i>restore</i>&nbsp;FILE</td><td valign=top>
            <p>This comman restores FILE from \$backupdir to \$datadir.
            There is no need to add the &quot;.dmr&quot; extension, as 
            DMR will do it for you.</p>
        </td></tr>

		<tr><td valign=top><i>unset</i>&nbsp;MAILINFOFILE</td>
		<td valign=top>
			<p>Use <i>unset</i> to remove the password cookie for a 
			particular <a href="#files">MAILINFOFILE</a>.</p>
		</td></tr>

		</table>
	</ul>
</p>

<p> 
	<b>BUTTONS</b><br>
	<ul>
		<p>The main DMR form consists of the following buttons. Some
		buttons have screens associated with them. These screens have
		buttons which are also defined here. The form has a target of
        &quot;_self&quot; to avoid loops with |iframe|.</p>

		<table cellpading=5 cellspacing=5>
		<tr><td valign=top><u>Go!</u></td><td valign=top>
			<a name="go"></a>
			<p>The <u>Go!</u> button has two functions. The first 
			is to submit any data that is in the text-box portion 
			of the form. The second is to reset DMR to the default 
			screen if the text-box is empty. This button is in the CSS
            class &quot;gobutton&quot;.</p>
		</td></tr>

		<tr><td valign=top><u>Reset</u></td><td valign=top>
			<a name="reset"></a>
			<p>The <u>Reset</u> button will return the text-box 
			portion of the form to the state it was in when the 
			screen was rendered. This button is in the CSS class
            &quot;resetbutton&quot;.</p>
		</td></tr>

		<tr><td valign=top><u>Aliases</u></td><td valign=top>
			<a name="aliases"></a>
			<p>The <u>Aliases</u> button will display the Aliases 
			screen. Clicking this button has the same effect as 
			using the <a href="#adisplay"><i>$adisplay</i></a> 
			command. Any alias that does not use <a 
			href="#varsub">variable substitution</a> and begins with
			&quot;http://&quot; will be rendered as a clickable 
			link. Clicking on such a link will not enter that alias 
			into the DMR <a href="#historydef">history</a>. This button
            is in the CSS class &quot;aliasesbutton&quot;.</p>

			<p>
				<b>BUTTONS</b><br>
				<ul>
				<table cellpadding=9><tr>
				<td valign=top><u>Delete</u></td> 
				<td valign=top><p>Deletes selected aliases from 
				the history/notes/aliases file.</p></td>
				</tr><tr>
				<td valign="top"><u>Select&nbsp;All</td>
				<td valign="top"><p>Uses Javascript to select
				all entries for easier deletion.</td>
				</tr><tr>
				<td valign="top"><u>Deselect&nbsp;All</td>
				<td valign="top"><p>Uses Javascript to deselect
				all entries.</td>
				</tr></table>
			</p>
		</td></tr>

		<tr><td valign=top><u>Notes</u></td><td valign=top>
			<a name="notes"></a>
			<p>The <u>Notes</u> button will display the Notes 
			screen. Clicking this button has the same effect as 
			using the <a href="#ndisplay"><i>$ndisplay</i></a> 
			command. This button is in the CSS class 
            &quot;notesbutton&quot;.</p>

			<p>
				<b>BUTTONS</b><br>
				<ul>
					<table cellpadding=9><tr>
					<td valign=top><u>Delete</u></td>
					<td valign=top><p>Deletes selected notes
					from the history/notes/aliases file.</p>
					</td></tr><tr>
					<td valign="top"><u>Select&nbsp;All</td>
					<td valign="top"><p>Uses Javascript to select
					all entries for easier deletion.</td>
					</tr><tr>
					<td valign="top"><u>Deselect&nbsp;All</td>
					<td valign="top"><p>Uses Javascript to deselect
					all entries.</td>
					</tr></table>
				</ul>
			</p>
		</td></tr>

		<tr><td valign=top><u>Edit</u></td><td valign=top>
			<a name="edit"></a>
			<p>The <u>Edit</u> button will display the 
			history/notes/aliases editor. Clicking this button has 
			the same effect as using the <a 
			href="#editvar"><i>$edit</i></a> command.
            This button is in the CSS class &quot;editbutton&quot;.</p>  

			<p>
				<b>BUTTONS</b><br>
				<ul>
					<table cellpadding=9><tr><td valign=top>
					<u>Save&nbsp;Changes</u></td>
					<td valign=top><p>Saves any changes you 
					have made to the data.</p></td></tr>
					<tr><td valign=top><u>Reset</u></td>
					<td valign=top><p>See <a href="#reset">
					<u>Reset</u></a></p></td></tr></table>
				</ul>
			</p>
		</td></tr>

		<tr><td valign=top><u>Views</u></td><td valign=top>
			<a name="views"></a>
			<p>The <u>Views</u> button will display a list of known 
			views.  This list consists of any file ending in the 
			.dmr extension that is not the history/notes/aliases 
			file defined by <a href="#usernamevar">\$username</a>.
            This button is in the CSS class &quot;viewsbutton&quot;.
			</p>

			<p>If (a) view(s) have been defined, the following 
			operations will be available from this screen:

			<p>
				<b>BUTTONS</b><br>
				<ul>
					<table cellpadding=9>
					<tr>
					<td valign=top><u>Delete</u></td> 
					<td valign=top><p>Deletes selected view 
					files from the filesystem.</p></td>
					</tr>
					<tr>
					<td valign=top><u>Edit</u></td>
					<td valign=top><a name="vedit"></a> 
					<p>Displays the <a 
					href="#edit"><u>Edit</u></a> screen 
					with the contents of the selected view 
					loaded for editing. If multiple views 
					are selected, the view at the bottom of 
					the list will be loaded.</p></td>
					</tr>

					<tr>
					<td valign=top><u>MakeCurrent</u></td>
					<td valign=top><a name="makecurrent"></a> 
					<p>Sets a cookie defining the selected 
					view as the <a href="#viewdef">view</a> 
					to be used. If multiple views are 
					selected, the view at  the bottom of the
					list will be used.</p></td>
					</tr>
					</table>
				</ul> 
			</p>
		</td></tr>

		<tr><td valign=top><u>ECV</u></td><td valign=top>
			<a name="ecv"></a>
			<p><u>ECV</u> is short for Edit Current View. This will 
			load the <a href="#makecurrent">current view</a> into 
			the <a href="#edit">Edit</a> screen. If no <a 
			href="#viewdef"> view</a> cookie is present, this button
			will not render. This button is in the CSS class
            &quot;ecvbutton&quot;.</p>
		</td></tr>

		<tr><td valign=top><u>History</u></td><td valign=top>
			<a name="history"></a>
			<p>The <u>History</u> button will display a time-ordered
			list of <a href="#historydef">history</a> entries, with 
			the newest entries at the top. Clicking on a history 
			entry will update its time stamp and move it to the top 
			of the list as well as redirecting you to the URL this 
			history entry represents. If history has been turned of 
			via <a href="#hoffvar">\$hoff</a> this button will not 
			render. This button is in the CSS class &quot;historybutton&quot;.
            </p>

			<p>
				<b>BUTTONS</b><br>
				<ul>
					<table cellpadding=9><tr>
					<td valign=top><u>Delete</u></td>
					<td valign=top><p>Deletes selected 
					history entries from the 
					history/notes/aliases file.</p>
					</td></tr><tr>
					<td valign="top"><u>Select&nbsp;All</td>
					<td valign="top"><p>Uses Javascript to select
					all entries for easier deletion.</td>
					</tr><tr>
					<td valign="top"><u>Deselect&nbsp;All</td>
					<td valign="top"><p>Uses Javascript to deselect
					all entries.</td>
					</tr></table>
				</ul>
			</p>
		</td></tr>

		<tr><td valign=top><u>Skip&nbsp;History</u></td><td valign=top>
			<p>If this select box is checked, the data currently in 
			the text-box portion of DMR will not be entered into 
			<a href="#historydef">history</a> when the form is 
			submitted.  If history has been turned of via <a 
			href="#hoffvar">\$hoff</a> this button will not 
			render. This checkbox (and the text after it) are in
            the CSS class &quot;skiphistory&quot;.</p>
		</td></tr>

		<tr><td valign=top><u>Help</u></td><td valign=top>
			<a name="help"></a>
			<p>The help button displays this help screen. It is 
			possible to toggle the rendering of this button with 
			<a href="#helpbutton"><i>helpbutton</i></a> and <a 
			href="#nohelpbutton"><i>nohelpbutton</i></a>. This
            button is in the CSS class &quot;helpbutton&quot;.</p>
		</td></tr>
		</table>
	</ul>
</p>

<p>
    <b>DMR REMOTE</b><br>
    <a name="dmrremote"></a>
    <ul>
        <p>The DMR Remote is a small (140x300) window with a simplified 
        entry form that allows you to use most of the features of DMR without
        loading DMR in your main browser window. The DMR Remote was created
        for aliasing/noting a URL without having to leave that URL and open
        DMR.</p>

        <p>By adding <a href="#bookmarklet">|bookmarklet|</a> to your view,
        you can make a bookmark entry for the DMR Remote. Clicking on that
        bookmark will launch the DMR Remote in a new window. The DMR Remote
        will control only the window that launched it. It is possible to use
        as many DMR Remotes as you want, but it may be cumbersome to keep
        track of which one belongs to which window with many of them open.</p>

        <p>Data entered into the DMR Remote will manifest in the controlled 
        window. If you enter an alias or URL, that URL (or alias data) will 
        load in the window that launched the DMR Remote. If the controlled 
        window closes, data entered into the &quot;orphaned&quot; DMR Remote 
        will enter into history (if applicable) but have no other function.</p>

        <p>The DMR Remote does not support all DMR commands. Here's a list
        of those that don't work.<br>
        <ul>
        <li>help
        <li>dmr
        <li>//
        <li>History/Aliases/Notes display
        <li>listviews
        <li>any of the editing functions
        </ul></p>

        <p>
            <b>BUTTONS</b><br>
            <ul>
                <table cellpadding=9><tr>
                <td valign=top><u>Go</u></td>
                <td valign=top><p>See above <u>Go</u> button entry</p></td></tr>
                <tr><td valign=top><u>Reset</u></td>
                <td valign=top><p>See above <u>Reset</u> button entry</p></td></tr>
                <tr><td valign=top><u>Home</u></td>
                <td valign=top><p>Returns the controlled window DMR's location</p></td></tr>
                <tr><td valign=top><u>Close</u></td>
                <td valign=top><p>Closes the DMR Remote</p></td></tr></table>
            </ul>
        </p>
    </ul>
</p>


<p> 
	<b>CREATING VIEWS</b><br>
	<a name="creatingviews"></a>
	<ul>
		<p>The DMR view system uses HTML and a few DMR-specific keywords
		to provide a templating system by which all DMR screens are 
		rendered. Keywords and their arguments <b>must</b> be alone on 
		a single line with the keyword itself at the beginning of a 
		line.</p>
        <p>The view system uses a cookie to specify the default view
        to be parsed. This cookie can be overridden in the URL like so:
        <br />http://127.0.0.1/dmr.php?view=myview<br />
        </p>

	<p>
		<b>KEYWORDS</b><br>
		<ul>
			<table cellspacing=5 cellpadding=5>

		<tr><td valign=top>&lt;!-- HEADER --&gt;</td><td valign=top>
			<p>Anything above this HTML comment will be used as the 
			beginning HTML for all DMR screens. Neither this 
			keyword, nor &lt;!-- FOOTER --&gt; are required in a 
			view, and one does not require the other.</p>
		</td></tr>

		<tr><td valign=top>&lt;!-- FOOTER --&gt;</td><td valign=top>
			<p>Anything below this HTML comment will be used as the 
			ending HTML for all DMR screens. Neither this keyword, 
			nor &lt;!-- HEADER --&gt; are required in a view, and 
			using one does not require the other.</p>
		</td></tr>

			<tr><td valign=top>|aliases| [<i>str</i> SEPARATOR]</td><td valign=top>
			<p>|aliases| prints a &lt;p 
			class=&quot;aliases&quot;&gt; containing a list of your 
			aliases, separated with the optional <i>SEPARATOR</i> argument.
            If no argument is provided, the list is separated with &lt;br&gt; 
            tags. Note that anything, including whitespace after the first space
            is considered to be a separator. This differs 
			from the output of the <a href="#aliases">Aliases</a> 
			screen in that the URL portion of the alias is not 
			displayed.</p>
			</td></tr>

			<tr><td valign=top>|date| [+/-<i>int</i>]</td><td valign=top>
			<p>|date| prints the current date and time. An optional
			argument will add or subtract hours to compensate for
			timezones.</p>
			<p>
				<b>EXAMPLE</b><br>
				<ul>|date| -2</ul>
				<p>Would produce the current server time -2 hrs.</p>
			</p> 
			</td></tr>

			<tr><td valign=top>|bookmarklet|</td><td valign=top>
            <a name="bookmarklet"></a>
            <p>This keyword prints the javascript to open the 
            <a href="#dmrremote">DMR&nbsp;Remote</a>. Use your browser's 
            &quot;Make a bookmark for this link&quot; feature to make use
            of it on non-DMR pages.</p>
            </td></tr>

			<tr><td valign=top>|form|</td><td valign=top>
			<p>Place this keyword where you want DMR to render the 
			DMR form.  Every form <b>must</b> have this keyword. 
			(|form| is the only non-optional keyword.) If your view 
			does not have this keyword, DMR will add the form at 
			the end of its output.</p>
			</td></tr>

			<tr><td valign=top>|fortune|</td><td valign=top>
			<p>If fortune is installed in /usr/games/fortune, this 
			keyword will print a fortune (within 
			&lt;pre&gt;&lt;/pre&gt;) every time you load DMR.</p>
			</td></tr>

			<tr><td valign=top>|history| [<i>int</i> LIMIT]</td>
			<td valign=top>
			<p>This keyword prints a &lt;p 
			class=&quot;history&quot;&gt; containing the history 
			entries. An optional argument will print only <i>n</i> 
			history entries.</p>
			</td></tr>

			<tr><td valign=top>|iframe|&nbsp;[<i>int</i>&nbsp;HEIGHT&nbsp;<i>int</i>&nbsp;WIDTH]&nbsp;[<i>str</i>&nbsp;URL]</td>
			<td valign=top>
			<p>If this keyword is used, commands that would result 
			in a redirect will be targeted in an IFRAME of a height 
			and width that you define. This IFRAME will be named 
			&quot;dmr&quot; if you wish to target HREF's to it. 
			The URL argument is the default URL to be loaded in the 
			IFRAME when DMR loads initially. This argument is 
			optional. You may wish to add<br>
            &lt;base target=&quot;dmr&quot;&gt;<br>
            to the &lt;head&gt; section of your view so that all links
            that don't have a defined target will automatically target
            the iframe.</p>
			</td></tr>

			<tr><td valign=top>|imap|&nbsp;<i>str</i>&nbsp;MAILINFOFILE</td>
			<td valign=top>
			<a name="imap"></a>
			<p>The IMAP notifier is activated with this keyword and 
			its argument. The argument should contain only the short
			name of the file and not the PHP file extension defined 
			in <a href="#phpextvar">\$phpext</a>. The syntax of the 
			MAILFILE is described <a href="#files">below</a>.</p>

			<p>When first loaded, each IMAP notifier will prompt the
			user for the password associated with the account in 
			that particular MAILINFOFILE. This password will be kept
			in <b>plain text</b> as a cookie that lasts for the life
			of the browser session. If you accidentally set the 
			wrong password, use <a href="#unset"><i>unset</i></a> to
			clear the cookie. Unless both your IMAPD and your PHP 
			installations have SSL support, your password will be 
			sent in <b>plain text</b> between the PHP server and the
			IMAP server.</p>
			<p>The CSS class of the &lt;tr&gt; in which the data 
			will be presented is the same as the the name of the 
			MAILFILE. In the example below, the &lt;tr&gt;s would 
			have the CSS class &quot;work-inbox&quot;. The number 
			assigned to each IMAP message is a button that will 
			display the contents of the message when clicked.</p>
			<p>Each element of the IMAP notifer table is
			classed to provide maximum flexibility. The first
			table cell contains the message flags. Its class is
			&quot;<i>msgflags</i>&quot;. The second cell contains
			the index number of the message and is classed 
			&quot;<i>msgnum</i>&quot;. The third cell contains
			the timestamp of the message and is classed
			&quot;<i>msgdate</i>&quot;. The fourth cell contains
			the From: field of the message and is classed 
			&quot;<i>msgfrom</i>&quot;. The fifth cell contains
			the message subject and is classed 
			&quot;<i>msgsubj</i>&quot;. Any of these elements
			can be disabled with CSS. For example:<br>
			<i>.msgflags, .msgdate { display: none }</i></p>
			<p>Using this option will slow down the rendering of DMR
			every time the cache expires.</p>
			<p>This functionality has been tested with the UWASH 
			IMAPD, your mileage may vary.</p>
			<p>In the example below, the name of the MAILINFO file 
			on the filesystem is &quot;work-inbox.php&quot; 
			(assuming the &quot;.php&quot; PHP file extension.)</p>

			<p>
				<b>EXAMPLE</b><br>
				<ul>|imap| work-inbox</ul>
			</p> 
		</td></tr>

			<tr><td valign=top>|include|&nbsp;<i>str</i>&nbsp;FILE</td>
			<td valign=top>
			<p>Use this to include a local file (in \$datadir) or
			a remote file via HTTP. |include|ed files are included
			&quot;as-is&quot; and are not parsed by the view system.
			This facility does no caching so using it with remote 
			documents will slow page rendering <i>every</i> time 
			the page s loaded.</p>
			<p><b>Examples:</b><br>
			<ul>|include| blah.inc<br>
			|include| http://linuxtoday.com/backend/lthead.inc</ul>
			</p>
			</td></tr>

			<tr><td valign=top>|link|&nbsp;<i>str</i>&nbsp;URL[<i>URL TEXT</i>]</td>
			<td valign=top>
			<p>|link| is a quick and easy way to add a link to a
			view. The text of the link is an optional argument.
            Just like the DMR main form, it will take partial
			URL's and add http:// if no protocol is found.</p>
			<p><b>Example:</b><br>
			<ul>|link| www.deadman.org<br>
			|link| ftp://ftp.ftp.org<br>
            |link| www.freebsd.org FreeBSD homepage</ul></p>
			</td></tr>

			<tr><td valign=top>|notes|</td><td valign=top>
			<p>This keyword prints a &lt;p 
			class=&quot;notes&quot;&gt; containing the notes entries
			separated with &lt;br&gt; tags. It differs from the 
			rendering of the <a href="#notes">Notes</a> screen in 
			that it does not give the option to delete notes.</p>
			</td></tr>

			<tr><td valign=top>|rdf|&nbsp;<i>str</i> URL [&quot;img&quot;] [<i>int</i> CACHETTL] [limit=<i>n</i>]</td>
			<td valign=top>
				<a name="rdf"></a>
				<p>DMR provides support for RDF handling via 
				<a href="http://nwow.org/">rssparse</a> by 
				j@nwow.org. Add this keyword, followed by a space and then 
                the URL to the RDF document you wish to parse. Some
                RSS documents have an image associated with them. If you
                wish to see this image, simply add <i>img</i> to the end
                of the |rdf| line. The CACHETTL is the number of minutes
                to use the cached file. Raising this number improves 
                performance. The minimum and default value is 15. The third
                argument limits the number of headlines presented.</p>
                <p>The CSS class of the &lt;p&gt; in which the data is 
				presented will be the same as the hostname from 
				which the data is taken, minus any period 
				characters. CSS classes don't like having 
				periods in their names.  In the example below, 
				the &lt;p&gt; would have a CSS class of 
				&quot;freshmeatnet&quot;.</p>
				<p>Using this option will slow down the 
				rendering of DMR every time the cache expires.
				</p>
				<p>
					<b>EXAMPLE</b><br>
					<ul>
						<p>To render the freshmeat.net 
						headlines, using their defined image, refreshing
                        every 20 minutes and showing only the first 12 
                        headlines, add the following, by itself on a 
						single line:</p><br> 
						|rdf| http://freshmeat.net/backend/fm.rdf img 20 limit=12
						</p>
					</ul>
				</p>

                <p>DMR's default behavior is to <b>not</b> render the 
                Description data for RSS items. This can be toggled using 
                the \$useRssItemDescription variable in the config file.
                If set to 1, Description data will be rendered with the CSS
                class similar to the above, but with &quot;itemdesc&quot;
                appended. For example: freshmeat.net's item descriptions would
                be in the CSS class <i>freshmeatnetitemdesc</i>.</p>
				<p>DMR only supports well-formed RSS 
				documents.</p>
			</td></tr>

		</table>
	</ul>
</p>

<p>
	<b>EXAMPLES</b><br>
	<ul> Here are some example views.<br>

		<table cellpadding=5 cellspacing=10>
		<tr><td>
		<table border=1>
			<tr><td>
			&lt;html&gt;<br>&lt;body bgcolor="white" 
			text="black"&gt;<br>|form|<br>&lt;/body&gt;<br>
			&lt;/html&gt;<hr>
			<p>The above is the simplest possible view.</p>
			</td></tr>
		</table>
		</td></tr>

		<tr><td>
		<table border=1>
			<tr><td>
			&lt;html&gt;<br>&lt;head&gt;<br>&lt;title&gt;
			Insinkerator's World&lt;/title&gt;<br>&lt;style 
			type=&quot;text/css&quot;&gt;<br><ul>&lt;!--<br>input 
			{ font-size: medium }<br>.work-inbox { font-face: fixed 
			; font-size: small }<br>A { font-face: application ; 
			text-decoration: none }<br>.history {font-size: 8pt}<br>
			--&gt;</ul> &lt;/style&gt;<br>&lt;body 
			bgcolor=&quot;black&quot; link=&quot;silver&quot; 
			alink=&quot;silver&quot; vlink=&quot;silver&quot; 
			text=&quot;white&quot;&gt;<br>&lt;!-- HEADER --&gt;<br>
			&lt;div align=center&gt;<br>&lt;table cellpadding=5 
			border=0&gt;<br> &lt;tr&gt;&lt;td colspan=2&gt;<br>
			|form|<br>&lt;/td&gt; &lt;/tr&gt;<br>
			&lt;tr&gt;&lt;td&gt;<br><ul>&lt;a 
			href=&quot;http://www.deadman.org&quot;&gt;Deadman.org&lt;/a&gt;&lt;br&gt;<br>
			&lt;a href=&quot;http://www.linuxtoday.com&quot;&gt;LinuxToday.com&lt;/a&gt;&lt;br&gt;<br>
			&lt;a href=&quot;http://www.debianplanet.org&quot;&gt;Debianplanet.org&lt;/a&gt;&lt;br&gt;<br>
			&lt;a href=&quot;http://www.boufdot.org&quot;&gt;Boufdot.org&lt;/a&gt;&lt;br&gt;<br>
			&lt;a href=&quot;http://www.memepool.com&quot;&gt;memepool.com&lt;/a&gt;&lt;br&gt;<br>
			&lt;a href=&quot;http://www.imdb.com&quot;&gt;imdb.com&lt;/a&gt;&lt;br&gt;<br>
			&lt;a href=&quot;http://www.jodi.org&quot;&gt;jodi.org&lt;/a&gt;&lt;br&gt;<br>
			</ul>&lt;/td&gt;&lt;td&gt;<br><br>|imap| work-inbox<br><br>&lt;/td&gt;
			&lt/tr&gt;<br>&lt;tr&gt;&lt;td colspan=2&gt;<br><br>|history|&nbsp;10<br><br>
			&lt;/td&gt;&lt;/tr&gt; &lt;/table&gt;<br>&lt;/div&gt;<br>
			&lt;!-- FOOTER --&gt;<br>&lt;/body&gt;&lt;/html&gt;

			</p><hr><p>The above example is more complex, using more
			advanced HTML, CSS and DMR keywords. The HTML/CSS prior 
			to &lt;!--&nbsp;HEADER&nbsp;--&gt; and following 
			&lt;!--&nbsp;FOOTER&nbsp;--&gt; will be used by 
			<i>all</i> DMR screens as long as this view is active. 
			This view would require a well-formed MAILINFO file 
			named &quot;work-inbox.php&quot; to exist on the server 
			in the data directory defined in the <a 
			href="#datadirvar">\$datadir</a> variable.</p>

			<p>Notice the optional argument to |history|. Only the 
			10 most recent history entries will be printed in this 
			case.
			</td></tr>
			</table>
			</td></tr>

			<tr><td>
			<table border=1>
			<tr><td>
			&lt;html&gt;<br>&lt;head&gt;<br>&lt;title&gt;Earl 
			Sucks&lt;/title&gt;<br>&lt;style 
			type=&quot;text/css&quot;&gt;<br><ul>&lt;!--<br>
			.fmrdf { font-size: medium }<br>.notes { font-face: 
			fixed ; font-size: small }<br>.aliases {font-size: 
			8pt}<br>--&gt;</ul> &lt;/style&gt;<br>&lt;body 
			bgcolor=&quot;black&quot; text=&quot;white&quot;&gt;<br>
			&lt;!-- HEADER --&gt;<br>&lt;table&gt;&lt;tr&gt;&lt;td 
			colspan=3 align=&quot;center&quot;&gt;<br>|form|<br>
			&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;<br>|notes|
			<br>&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;<br>
			|aliases|<br>&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;
			<br>|rdf| http://freshmeat.net/backend/fm.rdf<br>
			&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;&lt;/body&gt;&lt;/html&gt;
			<hr><p>This view also uses CSS to format the output of 
			DMR keywords. Note that this view uses 
			&lt;!--&nbsp;HEADER&nbsp;--&gt; without using 
			&lt;!--&nbsp;FOOTER&nbsp;--&gt;.</p>
			</td></tr>
			</table>
			</td></tr>
		</table>
	</ul>
</p>

<a name="files"></a>
<p> 
	<b>FILES</b><br>
	<ul>
		<p><b>IMPORTANT:</b> Due to the fact that DMR has the capability
		to create files on the server, it is possible for an 
		authenticated browser to launch a denial of service attack on 
		the server.</p>

		<table cellpading=5 cellspacing=5>
		<tr><td valign=top>views</td><td valign=top>
		<p>Views are created by entering the <a 
		href="#edit"><i>edit</i></a> command with the name of the view 
		as the argument. See also: <a 
		href="#creatingviews">CREATING&nbsp;VIEWS</a></p>
		</td></tr>

		<tr><td valign=top>history/notes/aliases</td><td valign=top>
			<p>The name of this file is defined in <a 
			href="#usernamevar">\$username</a>. It contains the 
			history, notes and aliases data.</p>
		</td></tr>

		<tr><td valign=top>mail&nbsp;files</td><td valign=top>
			<p>Each instance of the DMR <a href="#imap">IMAP 
			notifier</a> uses two files. The first file is the 
			MAILINFO file which contains information about the mail 
			account that should be checked. For security reasons, 
			this file is not viewable or editable from within DMR. 
			The user must create it in the directory defined in the 
			<a href="#datadirvar">\$datadir</a> variable. The file 
			should have a descriptive name. Make sure it ends with 
			your web server's PHP extension (usually 
			&quot;.php&quot;) which is defined in the <a 
			href="#phpextvar">\$phpext</a> variable in DMR. If 
			the \$phpext variable has been set incorrectly, the 
			IMAP notifier will not function and your MAILINFO file 
			may be readable by anyone who finds it on the web.</p>
			<p>The second file is the cache used for each instance 
			of the IMAP notifier. The name of the file is that of 
			the MAILINFOFILE with the extension of 
			&quot;.dmrmc&quot;. </p>

			<p> 
				<b>SYNTAX</b><br>
				<ul>
					<p>The MAILINFO file uses the following 
					syntax. Since it is a PHP document, it 
					must start and end with proper PHP 
					opening/closing tags.</p>
					<br><table cellpadding=3>
					<tr><td colspan=2>&lt;?</td></tr>
					<tr><td>\$userid="myuserid";</td>
					<td>//The IMAP username</td></tr>
					<tr><td>\$host="myhost:port";</td>
					<td>//The IMAP host and port seperated 
					with a : (IMAP is usually 143)</td></tr>
					<tr><td>\$amount=5;</td>
					<td>//The number of messages to display
					</td></tr>
					<tr><td>\$poll=15;</td>
					<td>//How often to refresh<br></td></tr>
					<tr><td colspan=2>?&gt;</td></tr>
					</table><br>
				</ul>
			</p>
		</td></tr>

		<tr><td valign=top>rdf&nbsp;files</td><td valign=top>
			<p>These files are downloaded whenever the <a 
			href="#rdf">|rdf|</a> keyword is used and will retain 
			the name they had on the remote server with a 
			prefix of the domain name of the server added to
			make them unique.</p>
		</td></tr>
		</table>
	</ul>
</p>

<p> 
	<b>AUTHOR</b><br>
	<ul>
		<p>DMR was written by Sam Rowe <a 
		href="http://www.deadman.org/">http://www.deadman.org/</a>. 
		Many thanks to Doug&nbsp;Ahern, Michael&nbsp;Hall, 
		Cary&nbsp;Whitley, Darrell&nbsp;Golliher, Ed&nbsp;Heil and Roadmaster 
        for help with this project.</p>

		<p>rssparse was written by j@nwow.org http://nwow.org.
		rssparse is covered by the GNU Lesser General Public License, 
        version 2.1 or later. Please see README.rssparse and COPYING.rssparse 
        for details.
		</p> 
	</ul>
</p>

END;
        printform();
        stfoot();
        exit;
}

?>
