<? 

include("rssparse.php");

function
getrdf($rdf,$useRDFimage, $rdfLimit){
    global $datadir,$useRssItemDescription;

    //Since we want the RDF cache to be host-specific, we need to
    //alter the name of the cache file.
    $url=parse_url($rdf);

    $rdffile=basename($rdf);
    $rdffile=$datadir.$url['host']."-".$rdffile;

    $rdfc=ereg_replace("\.","",$url['host']);
    $fp = fopen($rdffile,"r");
    $rss = rssparse($fp);

    if (!$rss) {
        printf ("Problems parsing %s",$rdffile);
        ERROR;
        return;
    }

    /*
    Stuff that rssparse.php makes available, but that DMR won't be using

    printf("<span class="rssdesc">Channel Description: %s <br></span>\n", $rss->desc);
    printf("Image Title: %s <br>\n", $rss->image["title"]);
    printf("Image Description: %s <br>\n", $rss->image["desc"]);
    printf("Image Link: %s <br>\n", $rss->image["link"]);
    */

    printf("<p class=\"%s\">\n",$rdfc);
    printf("<a href=\"%s\" class=\"channeltitle\">", $rss->link);
    if ( !empty ($rss->image["url"]) && $useRDFimage==1){
        printf("<img src=\"%s\"></a><br>\n", $rss->image["url"]);
    }else{
        printf("%s</a> <br>\n", $rss->title);
    }

    if( sizeof($rss->items) < $rdfLimit ){
        $rdfLimit=sizeof($rss->items);
    }

    //while (list(,$item) = each($rss->items)) {
    for ($q=0; $q<$rdfLimit; $q++){
        printf("<a href=\"%s\">", $rss->items[$q]["link"]);
        printf("%s</a>\n", $rss->items[$q]["title"]);
        if( $useRssItemDescription==1 ){
            printf("<span class=\"%sitemdesc\"> %s </span><br>\n",$rdfc, $rss->items[$q]["desc"]);
        }else{
            print("<br>\n");
        }
    }
    print("</p>\n");

    fclose($fp);
}

function
proxyrdf($rdffile,$rdf){
    global $proxyhost,$proxyport;
    $timeout=5;

    $local = fopen($rdffile, "w");
    $fp = fsockopen( $proxyhost, $proxyport, $errno, $errstr, $timeout);
    if ( !$fp ){ echo $errstr; return;} // just quit on error
    fputs($fp, "GET ".$rdf." HTTP/1.0\r\n\r\n");
    while (!feof($fp)){
        $rdfdata[] = fgets($fp, 1024);
    }
    $rdfdata=implode("",$rdfdata);
    $loc=strpos($rdfdata,"<");
    if ($loc === false){
        printf("Unable to parse.<br>\n");
    }else{  
       $rdfdata=substr($rdfdata,$loc);
    }
    fwrite($local,$rdfdata);

    fclose($fp);
    fclose($local);
}

/*  
    The following two classes were found at http://www.2113.ch/phplab/
    Please check out http://fravia.2113.ch/phplab/ and 
    http://www.searchlores.org/ for more of their great code.
*/


//This class is written by DQ.
//I call it 'DQ's turbo socket class' and believe me, it's not an 
//abusive name :-)
//It offers an easy way to work with php socket
//Its main advantage against standard php fsockopen() & co. functions is 
//SPEEEEEEEEEEEEEED !!

class socket {
  #public:
  var $errno=0;
  var $errstring='';
  #private:
  var $fp=0;
  var $sleeptime=0.5;   // minimum time between two successive reads
  var $nextread=0;
  var $timeout=0;       // checks when there's nothing more to read
  var $post_tout;
  var $buffer='';       // internal data buffer

  function socket($hostname,$port,$fsock_tout=10,$pre_tout=10,$post_tout)
  {
    if(empty($fsock_tout)||($fsock_tout<1)) $fsock_tout=10;
    $this->fp=fsockopen($hostname,$port,$this->errno,$this->errstring,$fsock_tout);
    if($this->fp) {
      socket_set_blocking($this->fp,FALSE);
      if(empty($pre_tout)||($pre_tout<1)) $pre_tout=10;
      if(empty($post_tout)||($post_tout<1)) $post_tout=$pre_tout;
      $this->post_tout=$post_tout;
      list($micro,$secs)=explode(' ',microtime());
      $now=$secs+$micro;
      $this->timeout=$now+$pre_tout;   // set initial timeout (usually longer)
    } // end if
  } // end function socket (constructor)

  function eof()
  {
    //end of file will be reached when connection is closed AND when buffer is empty
    return(($this->fp==FALSE) && empty($this->buffer));
  }

  //This routine will fill the buffer. It must be called from every state 
  //transition functions like data_available, receive_complete, read, ... 
  //in order to keep checking for the connection state

  function internal_read()
  {
    $result='';
    list($micro,$secs)=explode(' ',microtime());
    $now=$secs+$micro;
    if($now<$this->nextread) {
      usleep($this->sleeptime*1000000);         // avoid server overload
      $now+=$this->sleeptime;                   // update $now with new time
    } // end if
    $this->nextread=$now+$this->sleeptime; // mark earliest time for next read
    if($this->fp) {
      fread($this->fp,0);//bug workaround: we need to fread() to get updated socket_get_status()!
      $fp_stat=socket_get_status($this->fp);
      $avail=$fp_stat['unread_bytes'];
      if($avail>0) {
        $this->timeout=$now+$this->post_tout;
        $result=fread($this->fp,$avail);
      } else if($fp_stat['eof']||($now>=$this->timeout)) $this->close();
    } // end if
    return($result);
  }

  //Will return true when the connection is closed.
  //Either because of the end of reception or either because the 
  //connection could never be opened
  function receive_complete()
  {
   $this->buffer.=$this->internal_read(); //Let's check if any data available
   if ($this->fp==FALSE) return TRUE; else return FALSE;//If communication is over, fp is set to FALSE
  }

  //Will return true when some data are available in the buffer.
  //Or when the connection is over  !!!
  //This is needed in case the connection could never be opened. 
  //We should prevent infinite loop for data when there can't be any data !!
  function data_available()
  {
    $this->buffer.=$this->internal_read(); //Let's check if any data available
    //any data in the buffer ? or communication closed ?
    return (($this->fp==FALSE) || (strlen($this->buffer)>0));
  }

  function read()
  {
    if ($this->data_available()) $result=$this->buffer; else $result='';
    $this->buffer='';
    return ($result);
    //$result=empty($this->buffer)?($this->internal_read()):($this->buffer);
    //$this->buffer='';
    //return($result);
  }

  function readline()
  {
    $result='';
    while(1) {
      $p=strpos(' '.$this->buffer,"\n");
      if($p) {
        $result=substr($this->buffer,0,$p);
        $this->buffer=substr($this->buffer,$p);
        break;
      } // end if
      if($this->fp==FALSE) {//End of connection. Nothing more to expect.
        $result=$this->buffer;// send back everything collected up to now
        $this->buffer='';//Need to clear buffer once it's read
        break;
      } // end if
      $this->buffer.=$this->internal_read();
    } // end while
    return($result);
  }

  function write($line)
  {
    if($this->fp) fwrite($this->fp,$line);
  }

  function close()
  {
    if($this->fp) fclose($this->fp);
    $this->fp=FALSE;
  }
}; // end class socket

/*
class user agent. Ask him to fetch a page for you

modification :
- 14/02/01 : added 'chunked_decode()' function to correctly handle 
chunked transfer-encoding

require('t_socket_2.inc'); // We need DQ's turbo socket to connect to the world
Version 2 support simultaneous connections
*/

class ua {
    var $RC = 0;         //HTTP return code
    var $RCString = '';  //HTTP return string

    var $Header='';      //Header array
    var $Content='';     //Page content (string)
    var $name = 'my little bot';

    //Private
    var $f = '';         //our t_socket
    var $info = array(); //some info we will carry on
    var $UseDNScache;


    function ua($ua='', $DNSMode=TRUE)
    {
        if (isset($ua)&& !empty($ua)) $this->name = $ua;
        if (isset($DNSMode)) $this->UseDNScache = $DNSMode;
    }

    //This should prevent many redundant dns query
    function gethostIP($aHost)
    {
        static $hosts;//static to allow hosts to be shared between all instances
        if (count($hosts)>0) {
            foreach($hosts as $host => $IP) if ($host==$aHost)  return $IP;
        }
        $IP = gethostbyname($aHost);
        if ($this->UseDNScache) $hosts[$aHost]=$IP;//check if we use a DNS cache
        return $IP;
    }

    function send_request($url,$headonly=false)
    {
        if (($url_array=parse_url($url)) !=FALSE) {
            $host = $url_array['host'];
            $hostip = $this->gethostIP($host);     //5/12/2000

            if (!isset($url_array['path'])) $url_array['path'] = '/';
            $this->f=new socket($hostip,80,20,20,20);
            if (!($this->f->eof())) {
                $this->f->write((($headonly)?"HEAD":"GET")." ".$url_array['path']);
                if (isset($url_array['query'])) $this->f->write('?'.$url_array['query']);
                $this->f->write(" HTTP/1.1\r\n");
                $this->f->write("Host: ".$url_array['host']."\r\n" );
                $this->f->write("User-Agent: ".$this->name."\r\n" );
                //Needed to tell the server to close the connection once the transfer is over. This speed up things
                $this->f->write("Connection: close\r\n");
                $this->f->write("Accept: */*\r\n" );
                $this->f->write( "\r\n" );
                return;         //Everything went fine, let's just return
            } else {
                $this->RC = -1;
                $this->RCString = $this->f->errstring;
            }
        } else {
            $this->RC=-1;
            $this->RCString='malformed URL';
        }
        $this->f->close();//Let's close the socket to indicate the communication is done
        unset($this->f);
    }

    function data_available() {
        if (!isset($this->f)) return true;//If the socket couldn't be opened we shouldn't wait for any reply
        //return $this->f->data_available();
        //echo('asking for socket state<br>');
        return $this->f->receive_complete();
    }

    function get_reply()
    {
        if (isset($this->f)) {  //Any socket to get data from ?
        if (!($this->f->eof())) { $Status = $this->f->readline();}
        if (preg_match('@(\d{3}) (.*)@',$Status,$reg_array)) {
            $this->RC = $reg_array[1];
            $this->RCString = $reg_array[2];
        }
        while(!($this->f->eof())) {
            $line = $this->f->readline();
            if ($line=="\r\n") break;
            list($name, $val) = explode(': ',$line);
            if (empty($val)) {$val = 'N/A';}
            $this->Header[strtolower($name)]=trim($val);
        }
        while (!($this->f->eof())) { $this->Content.=$this->f->readline();}
            $this->f->close();//Let's close the socket to tell communication is over
            unset($this->f);
        }
    }

    //Return a specific header content
    function GetHeader($name)
    {
        if (isset($this->Header[$name])) return $this->Header[$name];
        else return '';
    }

    //Some function to allow to carry on some information about the page we are fetching
    function set_info($var)
    {
        if (is_array($var)) $this->info=array_merge($this->info, $var);
    }

    function get_info()
    {
        return $this->info;
    }

    //This function will decode the "chunked' transfer coding
    //as defined in RFC2068 19.4.6
    function chunked_decode()
    {
        if ($this->getHeader('transfer-encoding')!='chunked') return;
        $buffer=$this->Content;
        $length = 0;
        $new='';
        $chunkend = strpos($buffer,"\r\n")+2;
        $temp = substr($buffer,0,$chunkend);
        $chunk_size=hexdec(trim($temp));
        $chunkstart=$chunkend;
        while ($chunk_size > 0) {
            $chunkend=strpos($buffer,"\r\n",$chunkstart+$chunk_size);
            if ($chunkend==FALSE) { //Just in case we got a broken connection
                $chunk=substr($buffer,$chunkstart);
                $new.=$chunk;
                $length+=strlen($chunk);
                break;
            }
            $chunk=substr($buffer,$chunkstart,$chunkend-$chunkstart);
            $new.=$chunk;
            $length += strlen($chunk);
            $chunkstart=$chunkend+2;
            $chunkend=strpos($buffer,"\r\n",$chunkstart)+2;
            if ($chunkend==FALSE) break; //Just in case we got a broken connection
            $temp=substr($buffer,$chunkstart,$chunkend-$chunkstart);
            $chunk_size=hexdec(trim($temp));
            $chunkstart=$chunkend;
        }
        //Any additional header : not implemented yet
        //      read entity-header
        //      while (entity-header not empty) {
        //       append entity-header to existing header fields
        //       read entity-header
        //      }
        //Update headers
        $this->Header['content-length'] = $length;
        unset($this->Header['transfer-encoding']);
        $this->Content=$new;
    }
};     //end class ua

// End code from http://www.2113.ch/

?>
